/*  Last edited: Aug  6 12:02 1996 (esr) */
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <string.h>

#define MAXLINE  10000     /* maximum input line length*/
#define NAMESIZE 40

/* program to create index for embl library in embl cdrom form */
/* this one gets the entry names and offsets and writes them to an ascii file 
   this file is sorted, then the next program converts the sorted file to binary
   and adds the header */

char patternENTRY[] = ">";

#define patmatch(L,P) (strncmp((L),(P),strlen(P))==0)

int main(int argc, char *argv[])
{
    FILE *ifp;
    FILE *ofp;
    char line[MAXLINE], *c;
    char entry_name[NAMESIZE+1];
    off_t entry_offset = 0;
    off_t sequence_offset = 0;
    long entries_in = 0;
    long entries_out = 0;
    int cp;

    printf("FastaEntryname1long - %d char namefield\n", NAMESIZE);
    
    if (argc != 4) {
	fprintf(stderr,"Usage: emblentryname1 filein fileout division\n");
	exit(2);
    }
    if ((ifp = fopen(argv[1],"r")) == NULL) {
	fprintf(stderr,"emblentryname1: Cannot open input file %s\n",argv[1]);
	exit(1);
    }
    if ((ofp = fopen(argv[2],"w")) == NULL) {
	fprintf(stderr,"emblentryname1: Cannot open output file %s\n",argv[2]);
	exit(1);
    }
    
    entry_name[0]='\0';
    while (fgets(line, MAXLINE, ifp)!=NULL) {

	if (patmatch(line, patternENTRY)) {

	    entry_offset = ftell(ifp) - strlen(line);

	    c = line+1;  cp = 0;
	    while (!isspace(*c) && *c && cp<NAMESIZE) entry_name[cp++] = toupper(*c++);
	    entry_name[cp] = 0;
	    entries_in++;

	    while (fgets(line, MAXLINE, ifp) && isspace(line[0]));

	    sequence_offset = ftell(ifp) - strlen(line);
	    
	    if (feof(ifp)) {
		/* Last entry has no sequence */
		sequence_offset = entry_offset;
	    }
	    
	    if (*line == '>') {
		/* No sequence - rewind so next entry isn't missed */
		sequence_offset = entry_offset;
		fseek(ifp, -strlen(line), SEEK_CUR);
	    }
		

	    fprintf(ofp,"%s %d %d %s\n", entry_name,
		    entry_offset, sequence_offset, argv[3]);
	    entries_out++;
	}
    }

    printf(" Number of entries read = %ld\n",entries_in); 
    printf(" Number of entries written = %ld\n\n",entries_out); 

    fclose(ifp);
    fclose(ofp);
    
    return 0;
}



