/*  Last edited: Jan 15 14:04 1995 (esr) */
/*         prositeentryname1           */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <string.h>

#define MAXLINE 81     /* maximum input line length*/

/* program to create index for prosite library in embl cdrom form */
/* this one gets the entry names and offsets and writes them to an ascii file 
   this file is sorted, then the next program converts the sorted file to binary
   and adds the header */

char patternENTRY[] = "ID";
char patternSEQUENCE1[] = "PA";
char patternSEQUENCE2[] = "RU";
char patternSEQUENCE3[] = "MA";

#define patmatch(L,P) (strncmp((L),(P),strlen(P))==0)

int main(int argc, char *argv[])
{
    FILE *ifp;
    FILE *ofp;
    char line[MAXLINE], *c;
    char entry_name[10];
    off_t entry_offset = 0;
    off_t sequence_offset = 0;
    long entries_in = 0;
    long entries_out = 0;
    int leftChar = 5;

    printf("prositeentryname1 Version 1.0\n");
    
    if (argc != 4) {
	fprintf(stderr,"Usage: prositeentryname1 filein fileout division\n");
	exit(2);
    }
    if ((ifp = fopen(argv[1],"r")) == NULL) {
	fprintf(stderr,"prositeentryname1: Cannot open input file %s\n",argv[1]);
	exit(1);
    }
    if ((ofp = fopen(argv[2],"w")) == NULL) {
	fprintf(stderr,"prositeentryname1: Cannot open output file %s\n",argv[2]);
	exit(1);
    }
    
    entry_name[0]='\0';
    while (fgets(line,MAXLINE,ifp)!=NULL){

	if (patmatch(line, patternENTRY)){

	    if (*entry_name)
		printf("No sequence for entry %s\n",entry_name);

	    entry_offset = ftell(ifp) - strlen(line);

	    if (!fgets(line,MAXLINE,ifp)) break;
	    if (c = (char *)strchr(line+leftChar, ';')) *c = 0;
	    strcpy(entry_name, line+leftChar);
	    entries_in++;

	} else if ( (patmatch(line, patternSEQUENCE1) || 
		     patmatch(line, patternSEQUENCE2) ||
		     patmatch(line, patternSEQUENCE3))
		   && *entry_name) {

	    sequence_offset = ftell(ifp);
	    fprintf(ofp,"%-10.10s %10ld %10ld %-5.5s\n",entry_name,
		    entry_offset,sequence_offset,argv[3]);
	    entries_out++;
	    entry_name[0]='\0';

	}

    }

    printf(" Number of entries read = %ld\n",entries_in); 
    printf(" Number of entries written = %ld\n\n",entries_out); 

    fclose(ifp);
    fclose(ofp);
    
    return 0;
}



